Bug 4878 - segfault when i386 client touches x86_64 server (no rsh/ssh) both cvs 3.0.0 today 20070813
segfault when i386 client touches x86_64 server (no rsh/ssh) both cvs 3.0.0 t...
Status: CLOSED FIXED
Product: rsync
Classification: Unclassified
Component: core
3.0.0
x86 Linux
: P3 normal
: ---
Assigned To: Wayne Davison
Rsync QA Contact
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2007-08-13 23:55 UTC by Brian K. White
Modified: 2008-07-26 10:11 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Brian K. White 2007-08-13 23:55:33 UTC
built rsync 3.0.0cvs on two machines today, 20070813

machine A, server, suse linux 10.2 x86_64
Linux bu1 2.6.18.8-0.5-default #1 SMP Fri Jun 22 12:17:53 UTC 2007 x86_64 x86_64 x86_64 GNU/Linux

machine B, client, suse linux 10.2 i386
Linux slosh 2.6.18.2-34-default #1 SMP Mon Nov 27 11:46:27 UTC 2006 i686 i686 i386 GNU/Linux

on both machines the ./configure command used was:
./configure --disable-debug --disable-ipv6 --prefix=/usr CFLAGS="-O2"

Both built without apparent error and both run without error at least locally.
That is,
* both run "rsync --version" with no error
* both can rsync local files

Server A:
* is running rsync --daemon
* is a backup/install server for my company and lots of machines hit it all the time both downloading and uploading. It's been doing fine all day running the new binary.
* the clients that hit this are all using rsync 2.6.9 or older, mostly SCO Open Server 5.0.[4567] i386 and Suse linux 9.x 10.x i386 & x86_64

Client B:
* new binary ran a 300 gig local rsync job from local raid array to local external usb drive with no problem. (empty drive so 300gb transferred, plus updates later also no problem)
* only segfaults when trying to do a network rsync, specifically:
export USER=foo RSYNC_PASSWORD=foo
rsync -av --del install.aljex.com::${USER}/foo/data /foo
* segfaults immediately, no other messages, no time at all spent, say, looking at local files to build the list.
* rebuilt with just ./config --PREFIX=/usr  no change
* built 2.6.9 with ./configure --disable-debug --disable-ipv6 --prefix=/usr CFLAGS="-O2" and the network rsync works perfect again.

Didn't try other possible debugging tests yet like trying with rsh or ssh instead of direct, or generating debug trace, or trying 3.0.0 to 3.0.0 where both server & client are the same platform or perhaps the same box even. or the reverse of what I tried, x86_64 3.0.0 client accessing i386 3.0.0 server.
Can try all that a little later.
Comment 1 Wayne Davison 2007-08-15 20:34:21 UTC
> * only segfaults when trying to do a network rsync, specifically:
> export USER=foo RSYNC_PASSWORD=foo
> rsync -av --del install.aljex.com::${USER}/foo/data /foo

There was a bug I had introduced a few days ago in daemon mode.  I just checked-in a fix, so this should be fine in the latest CVS (and latest "nightly" tar file).
Comment 2 Brian K. White 2007-08-16 08:45:14 UTC
Yep. Fixed.
Thanks much.